local LBI = LibStub("LibBossIDs-1.0")

local frame = _G.BattleStandardReminder or CreateFrame("Frame")
_G.BattleStandardReminder = frame

local GetTime=GetTime
local UnitGUID=UnitGUID
local UnitHealth,UnitHealthMax=UnitHealth,UnitHealthMax
local UnitExists,UnitIsTappedByPlayer=UnitExists,UnitIsTappedByPlayer
local tonumber = tonumber
local pairs = pairs
local wipe = wipe

local guids = setmetatable({}, {
      __index = function(self, key)
         local guid = tonumber(key:sub(-13, -9), 16) or 0
         self[key]=LBI.BossIDs[guid or 0] or false
         -- print(guid, self[key])
         return self[key]
      end
})

local lastWarn = 0

local partyMembers = {"party1","party2","party3","party4"}

local function check(unit)
	--[[ this triggers on all sorts of additional crap: if unit:match("^boss") then
		-- yes!
	else]]if UnitIsTappedByPlayer(unit) then
		if guids[UnitGUID(unit)] then
			-- yes!
		else
			return	-- nope
		end
	else
		return	-- nope
	end

	if UnitHealth(unit) / UnitHealthMax(unit) < 0.3 then
		if GetTime()>lastWarn+120 then
-- GLOBALS: print, format, UnitName, UnitIsInMyGuild, UnitIsPartyLeader, SendChatMessage		
			local msg = format("GuildStandardReminder: %s is at %.0f%%", UnitName(unit), 
				UnitHealth(unit) / UnitHealthMax(unit) * 100
			)
			local numGuildies=1
			for k,v in pairs(partyMembers) do
				if UnitIsInMyGuild(v) then
					numGuildies=numGuildies+1
				end
			end
			if numGuildies>=3 and UnitIsPartyLeader("player") then -- 3 including myself
				SendChatMessage(msg, "party")
			else
				print(msg)
			end
			lastWarn=GetTime()
		end
	  
	end


end

function frame:UNIT_HEALTH(event,unit)
   return check(unit)
end

function frame:UNIT_TARGET(event,srcunit)
   local unit = srcunit.."target"
   if UnitExists(unit) then
      return check(unit)
   end
end

function frame:ZONE_CHANGED(event)
   wipe(guids)
end



frame:SetScript("OnEvent", function(self,event,...)
      return self[event](self,event,...)
   end
)

frame:RegisterEvent("UNIT_HEALTH")
frame:RegisterEvent("UNIT_TARGET")
frame:RegisterEvent("ZONE_CHANGED")
